/*!
 * @file BufferedReader.h
 * @brief եɤ߹ߥХåե
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2005-01-26, 
 *
 * Copyright (C) 2005, Yashiro Takeshi
 */

#ifndef BUFFERED_READER_H
#define BUFFERED_READER_H

#include <basic.h>
#include <btron/file.h>
#include "Exception.h"

//! եɤ߹ߥХåե
/*!
 * եɤ߹ߤХåե󥰤뤿Υ饹Ǥ
 */
class BufferedReader {

  W filedes; //!< եǥץ

  static const int bufsize = 1024;

  B buff[bufsize]; //!< ɤ߹ߥХåե

  int bcur; //!< ɤ߹ߥХåեɤ߹߰
  int blen; //!< ɤ߹ߥХåեΥ

  W offset; //!< եɤ߽Ф֤Υեå

  mutable bool eof_state; //!< եνüãɤ

  //! EOFɤξ֤򹹿
  /*!
   * EOFɤ򡢼ºݤ˥ƥॳȤäĴ٤ƾ֤򹹿ޤ
   * @exception FileReadException եɤ߹߻˥顼
   */
  void renewEOFState() const {
    W rsize, err;
    err = rea_rec(filedes, offset, NULL, 0, &rsize, NULL);
    if (err < 0){
      throw FileReadException(filedes, err);
    }
    eof_state = (rsize <= 0);
  }

 public:

  //! 󥹥ȥ饯
  /*!
   * եǥץХåե󥰤륪֥Ȥޤ
   * @param fd оݤȤʤեǥץ
   * @exception FileReadException եɤ߹߻˥顼
   */
  BufferedReader(W fd)
    : filedes(fd), bcur(0), blen(0), offset(0)
  {
    renewEOFState();
  }

  //! EOFå
  /*!
   * եνüãɤ֤ޤ
   * @retval true եνüã
   * @retval false եνüãƤʤ
   */
  bool isEOF() const {
    return eof_state && (blen == bcur);
  }

  //! ɤ߹
  /*!
   * ե뤫ǡꤷХĹɤ߹ߤޤ
   * @param target [out] ǡγǼ
   * @param size [in] targetɤ߹ХĹ
   * @return ºݤɤ߹ǡĹ
   * @exception FileReadException եɤ߹߻˥顼
   */
  int read(B* target, int size);

  //! ɤФ
  /*!
   * եꤷХĹɤߤȤФޤ
   * @param size ɤФХĹ
   * @return ºݤɤФǡĹ
   * @exception FileReadException եɤ߹߻˥顼
   */
  int skip(int size);

};

#endif // BUFFERED_READER_H
