/*!
 * @file MainMenu.cc
 * @brief ᥤ˥塼()
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-10-31, first edition (for BSlide)
 * @date 2005-02-27, modified for Scribble
 * @date 2006-05-14, removed a bug
 *
 * Copyright (C) 2004-2005, Yashiro Takeshi
 */

#include <basic.h>
#include <btron/hmi.h>
#include <btron/vobj.h>
#include <btron/libapp.h>
#include "MainMenu.h"
#include "tcsliteral.h"
#include "Exception.h"
#include "databox.h"

static TC m_finish[]  = {TCS_MENU_FINISH};
static TC m_disp[]    = {TCS_MENU_DISP};
static TC m_save[]    = {TCS_MENU_SAVE};

static MENUITEM mitems[] = {
  {0L, 0L, 0, 0, m_finish},
  {0L, 0L, 0, 0, m_disp},
  {0L, 0L, 0, 0, m_save},
  {0L, 0L, 0, 0, NULL}, // ɥ
  {0L, 0L, 0, 0, NULL}, // ʪ
};

MainMenu::MainMenu()
: mid(-1)
{
  typedef std::pair<int, MainMenuItem> MConvPair;
  mcnv.insert(std::make_pair(0x001, MN_FINISH));
  mcnv.insert(std::make_pair(0x101, MN_REDISP));
  mcnv.insert(std::make_pair(0x201, MN_SAVE));
  //mcnv.insert(std::make_pair(0x301, MN_WINDOW));
  //mcnv.insert(std::make_pair(0x401, MN_GADGET));
  
  mid = mcre_men(sizeof(mitems)/sizeof(MENUITEM), mitems, NULL);
  if (mid < 0){
    throw PaneledFailureException(EPNL_MENU);
  }
}

// ˥塼ܤμμ
MainMenuItem MainMenu::getInternalID(int rid) const
{
  int wmidx = sizeof(mitems)/sizeof(MENUITEM);
  int major = rid >> 8;
  if (major == wmidx - 2){
    return MN_WINDOW;
  }
  else if (major == wmidx - 1){
    return MN_GADGET;
  }
  MConvMap::const_iterator p = mcnv.find(rid);
  if (p != mcnv.end()){
    return p->second;
  }
  return MN_VOID;
}

// ˥塼ɥɽ
W MainMenu::popupMenu(WEVENT* ev)
{
  int wmidx = sizeof(mitems)/sizeof(MENUITEM);

  wget_dmn(&(mitems[wmidx-2].ptr));
  mset_itm(mid, wmidx-2, &(mitems[wmidx-2]));
  oget_men(0, NULL, &(mitems[wmidx-1].ptr), NULL, NULL);
  mset_itm(mid, wmidx-1, &(mitems[wmidx-1]));
  
  setpointer(PS_SELECT, NULL);
  gdsp_ptr(-1);

  return msel_men(mid, ev->s.pos);
}

