/*!
 * @file MainWindow.h
 * @brief 祦ɥ
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2005-02-20, 
 *
 * Copyright (C) 2005, Yashiro Takeshi
 */

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <basic.h>
#include "MemoryDrawEnv.h"
#include "MainMenu.h"
#include "ScribbleDoc.h"

//! 祦ɥ
/*!
 * 祦ɥ򰷤饹Ǥ
 */
class MainWindow {
  
private:

  enum State { STATE_NORMAL, STATE_SELECTED };

  static const int scrlbar_width = 18;
  const LINK* bsfile;
  W wid;
  RECT wrect, cliprect;
  TC* title;
  PAT bgpat;
  MainMenu menu;
  MemoryDrawEnv mdenv;
  bool cont;
  ScribbleDoc doc;
  State state;

  std::auto_ptr<SelectionStroke> sel_stroke;
  std::auto_ptr<ScribbleDoc::DrawingStrokePtrList> sel_slist;

  //! ˥塼μ¹
  void selectMenu(WEVENT* ev, W mitem);

  //! 
  void draw();

  //! W_REDISPϥɥ
  void redisp(WEVENT* ev);

  //! EV_KEYDWNϥɥ
  void onKeyDown(WEVENT* ev);

  //! ΰǤκåбϥɥ
  void onMouseButtonDown(WEVENT* ev);

  //! åбϥɥ (STATE_NORMAL) 
  void onRightMouseButtonDown(WEVENT* ev);

  //! åбϥɥ (STATE_SELECTED)
  void onSelectedMouseEvent(WEVENT* ev, bool left);

  //! СǤκåбϥɥ
  void onScroll(WEVENT* ev);

  //! ɥΥϥɥ
  void onIdle(WEVENT* ev);

  //! Υ󥻥
  void cancelSelection();

public:
  
  //! 󥹥ȥ饯
  MainWindow();

  //! ǥȥ饯
  virtual ~MainWindow(){
    gdsp_ptr(-1);
    display(false);
  }
  
  //! ɥȤδϢŤ
  /*!
   * ɥ˥ɥȤϢŤɥȤɤ߹ߤޤ
   * @param link եؤΥ
   */
  void openDocument(const LINK* link);

  //! ɥIDμ
  /*!
   * ɥIDޤ
   * @return ɥID
   */
  W getWindowID() const {
    return wid;
  }

  //! ɥɽ/ɽڤؤ
  /*!
   * ɥɽ/ɽڤؤޤ
   * @param state ɽ
   */
  void display(bool state = true);

  //! ٥ȥ롼פμ¹
  /*!
   * ٥ȥ롼פ¹Ԥޤ(餫ᥦɥɽƤ
   * ֤ˤƤɬפޤ)
   */
  void run();

  //! ٥ȥ롼פæ
  /*!
   * ٥ȥ롼פμ¹Ԥߤޤ
   */
  void terminate(){
    cont = false;
  }

};

#endif // MAINWINDOW_H
