/*!
 * @file MemoryDrawEnv.h
 * @brief Ķ
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2005-02-26, 
 *
 * Copyright (C) 2005, Yashiro Takeshi
 */

#ifndef MEMORY_DRAWENV_H
#define MEMORY_DRAWENV_H

#include <basic.h>
#include <memory>

//! Ķ饹
/*!
 * Ķ뤿Υ饹Ǥ
 */
class MemoryDrawEnv {

 private:

  CSPEC cspec;
  B bitmap_entity[sizeof(BMP)+sizeof(UB*)*28];
  BMP* bmp;
  PAT pat;
  mutable GID gid;

  //! ǥեȤΥ顼ޥåפѰդޤ
  void getCSPEC();

  //! ӥåȥޥåפΥΰݤޤ
  void createBitmap();

  //! ӥåȥޥåפΥΰޤ
  void releaseBitmap() throw();

 public:
  
  //! 󥹥ȥ饯
  MemoryDrawEnv() : gid(-1), bmp(reinterpret_cast<BMP*>(bitmap_entity)) {
    bmp->baseaddr[0] = 0;
    setrect(bmp->bounds, 0, 0, SCREEN.hpixels, SCREEN.vpixels);
    bmp->planes = SCREEN.planes;
    bmp->pixbits = SCREEN.pixbits;
    pat.spat.kind = 0;
    pat.spat.vsize = pat.spat.hsize = 1;
    pat.spat.fgcol = 0x10ffffff;
    pat.spat.bgcol = 0x10000000;
    pat.spat.mask = FILL100;
    getCSPEC();
    createBitmap();
    clear();
  }

  //! ǥȥ饯
  ~MemoryDrawEnv() {
    if (gid > 0){
      gcls_env(gid);
    }
    releaseBitmap();
  }

  //! ɸ
  /*!
   * ĶκΥեåȤꤷޤ
   * @param p ɸ
   */
  void setPos(const PNT& p) {
    bmp->bounds.p.lefttop = p;
    bmp->bounds.c.right = bmp->bounds.c.left + SCREEN.hpixels;
    bmp->bounds.c.bottom = bmp->bounds.c.top + SCREEN.vpixels;
    if (gid > 0){
      gcls_env(gid);
    }
    gid = -1;
  }

  //! ɸμ
  /*!
   * ĶθߤκΥեåȤޤ
   * @return ɸ
   */
  const PNT& getPos() const {
    return bmp->bounds.p.lefttop;
  }

  //! ĶΥꥢ
  /*!
   * ĶطʥѥɤĤ֤ޤ
   */
  void clear() {
    gfil_rec(getGID(), bmp->bounds, &pat, 0, G_STORE);
  }

  //! ĶIDμ
  /*!
   * ĶбĶID֤ޤ(GID
   * gcls_envʤɤĤʤǤ)
   * @return ĶID
   */
  GID getGID() const;

  //! ӥåȥޥåפμ
  /*!
   * ĶбӥåȥޥåפؤΥݥ󥿤֤ޤ
   * @return ӥåȥޥåפؤΥݥ
   */
  const BMP* getBMP() const {
    return bmp;
  }

};

#endif // MEMORY_DRAWENV_H
