/*!
 * @file ScribbleDoc.h
 * @brief Scribbleɥ
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2005-01-26, 
 *
 * Copyright (C) 2005, Yashiro Takeshi
 */

#ifndef SCRIBBLE_DOC_H
#define SCRIBBLE_DOC_H

#include <basic.h>
#include <list>
#include "Stroke.h"

//! Scribbleɥȥ饹
/*!
 * ScribbleΤΥǡ¤ޤ
 */
class ScribbleDoc {

 private:

  // ǡݻ
  typedef std::list<DrawingStroke> DrawingStrokeList;
  typedef DrawingStrokeList::iterator DrawingStrokeIterator;
  typedef DrawingStrokeList::const_iterator DrawingStrokeConstIterator;

 public:

  // ʬ(ݥ)
  typedef std::list<DrawingStroke*> DrawingStrokePtrList;
  typedef DrawingStrokePtrList::iterator DrawingStrokePtrIterator;
  typedef DrawingStrokePtrList::const_iterator DrawingStrokeConstPtrIterator;
  
 private:

  //! 襹ȥΥꥹ
  DrawingStrokeList stroke;

  //! ǽ¸ι̵ͭ
  mutable bool modified;

  //! ϰϼ
  /*!
   * ȥ줿ϰϤޤ
   * @param bound [out] 줿ϰ
   */
  void calcBounds(RECT *bound) const;

 public:

  //! 󥹥ȥ饯
  ScribbleDoc() : modified(false) {}

  //! å
  /*!
   * ǽ¸ΥɥȤι̵֤ͭޤ
   * @return ̵ͭ
   */
  bool isModified() const {
    return modified;
  }

  //! 襹ȥɲ
  /*!
   * 襹ȥɥȤɲäޤ
   * @param s ä襹ȥ
   */
  void addStroke(const DrawingStroke& s){
    modified = true;
    stroke.push_back(s);
  }

  //! Ķؤ
  /*!
   * ɥȤĶξ褷ޤ
   * @param gid Ķ(GID)
   * @param lb ϰϤYɸβ
   * @param ub ϰϤYɸξ
   */
  W draw(W gid, int lb, int ub) const;

  //! ե뤫ɤ߹
  /*!
   * ե뤫ɥȤɤ߹ߤޤ
   * @param src ɤ߹оݤΥե
   * @retval true ̵뤵줿Ȥ¸
   * @retval false ƤΥȤͭ
   */
  bool load(const LINK* src);

  //! եؤ¸
  /*!
   * ɥȤե¸ޤ
   * @param dest ¸оݤΥե
   */
  void save(const LINK* dest) const;

  //! ǡξõ
  /*!
   * ɥȤΥǡõޤ
   */
  void clear(){
    modified = false;
    stroke.clear();
  }

  //! 
  /*!
   * Ϳ줿򥹥ȥбʬ֤ˤޤ
   * @param selection [out] 򤵤줿ȥ֤
   * @param selstroke 򤹤ΰ򼨤򥹥ȥ
   * @param lb Yɸβ
   * @param ub Yɸξ
   * @retval true 򤵤줿ȥ¸
   * @retval false Υȥ򤵤ʤä
   */
  bool select(DrawingStrokePtrList* selection, const SelectionStroke& selstroke, int lb, int ub);

  //! ֤Υ󥻥
  /*!
   * ֤򥭥󥻥뤷٤ƤΥȥ֤ˤޤ
   */
  void unselectAll();

  //! 򤵤줿ȥκ
  /*!
   * 򤵤줿ȥ򤹤٤ƺޤ
   */
  void removeSelected();

  //! 򤵤줿ȥΰư
  /*!
   * 򤵤줿ȥưޤ
   * @param dh Xΰư
   * @param dv Yΰư
   */
  void moveSelected(int dh, int dv);

};

#endif // SCRIBBLE_DOC_H
