/*!
 * @file Stroke.h
 * @brief ȥ
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2005-01-26, 
 *
 * Copyright (C) 2005, Yashiro Takeshi
 */

#ifndef STROKE_H
#define STROKE_H

#include <basic.h>
#include <vector>
#include <btron/dp.h>
#include <tad.h>
#include <btron/taddata.h>
#include <limits.h>

//! ݥȥ
/*!
 * ξޤࡢȥݥ饹Ǥ
 */
class AbstractStroke {

 protected:

  //! POLY¤ΤǼ뤿ΥХåե
  std::vector<PNT> poly;

  //! poly[]ƬʬΥإå˻Ȥǿ
  static const int sz_header = 1;

  int y_lbound; //!< Yɸβ
  int y_ubound; //!< Yɸξ

  bool sel; //!< 

  //! 󥹥ȥ饯
  AbstractStroke()
    : y_lbound(INT_MAX), y_ubound(INT_MIN), sel(false)
  {
    PNT p;
    reinterpret_cast<POLY*>(&p)->round = 0;
    reinterpret_cast<POLY*>(&p)->size  = 0;    
    poly.push_back(p);
  }

 public:

  //! Ƥξõ
  /*!
   * ȥƤõޤ
   */
  virtual void clear() = 0;

  //! POLY¤ΤؤΥ
  /*!
   * POLY¤ΤȤƥȥ˥뤿Υݥ󥿤ޤ
   * @return POLY¤ΤؤΥݥ
   */
  const POLY* getPoly() const {
    return reinterpret_cast<const POLY*>(&(poly[0]));
  }

  //! μ
  /*!
   * ȥκɸޤ
   * @return ɸ
   */
  PNT getPoint(int index) const {
    return poly.at(index + sz_header);
  }

  //! θĿμ
  /*!
   * ȥθĿޤ
   * @return θĿ
   */
  int getSize() const {
    return poly.size() - sz_header;
  }

  //! Yɸβ¤μ
  /*!
   * Yɸβ¤ޤ
   * @return Yɸβ
   */
  int getLowerBound() const {
    return y_lbound;
  }

  //! Yɸξ¤μ
  /*!
   * Yɸξ¤ޤ
   * @return Yɸξ
   */
  int getUpperBound() const {
    return y_ubound;
  }

  //! ɲ
  /*!
   * ɲäޤ
   * @param p ɲäκɸ
   */
  void addPoint(const PNT& p);

  //! եåȤˤư
  /*!
   * ȥ򥪥եåȤˤäưưޤ
   * @param dh Xɸΰư
   * @param dv Yɸΰư
   */
  void moveOffset(int dh, int dv);

  //! ϰϤ˴ޤޤ뤫å
  /*!
   * ϰ(lb, ub)˥ȥʬޤޤƤ뤫åޤ
   * @param lb Yɸβ
   * @param ub Yɸξ
   * @retval true ϰϤ˴ޤޤ
   * @retval false ϰϤ˴ޤޤʤ
   */
  bool hasIntersection(int lb, int ub) const {
    return (getSize() > 0 &&
            ((y_lbound < ub && y_lbound > lb)
             || (y_ubound < ub && y_ubound > lb)));
  }

};


//! 襹ȥ
/*!
 * ºݤб륹ȥǤ
 */
class DrawingStroke : public AbstractStroke {

  static int lwidth; //!< 
  static LATTR lattr; //!< °
  static PAT pat; //!< ѥ
  static PAT pat_sel; //!< ѥ()
  static DCM dcm; //!< ⡼

 public:

  //! 󥹥ȥ饯
  DrawingStroke() : AbstractStroke() {}

  //! 󥹥ȥ饯
  /*!
   * 󥹥ȥ饯Ǥ
   * @param p ǡΤȤȤʤTADζ
   */
  DrawingStroke(const TF_SPLINE *p) : AbstractStroke() {
    for (int i = 0; i < p->np; i++){
      addPoint(p->pt[i]);
    }
  }

  //! 
  /*!
   * ĶԤޤ
   * @param gid Ķ(GID)
   * @param lb Yɸβ
   * @param ub Yɸξ
   * @return 顼(0ʤｪλ)
   */
  W draw(W gid, int lb, int ub) const;

  //! 
  /*!
   * 褷ޤ(֤˴طʤ褷ޤ)
   * @param gid Ķ(GID)
   * @return 顼(0ʤｪλ)
   */
  W drawSelection(W gid) const {
    return gdra_pln(gid, (POLY*)&(poly[0]), lattr, &pat_sel, dcm);
  }

  //! Ǹ
  /*!
   * Ǹ줿ʬԤޤ
   * @param gid Ķ(GID)
   * @return 顼(0ʤｪλ)
   */
  W drawLatest(W gid) const {
    int sz = getSize();
    if (sz >= 2){
      return gdra_lin(gid, getPoint(sz-2), getPoint(sz-1), lattr, &pat, dcm);
    }
    return 0;
  }

  virtual void clear();

  //! ֤ڤؤ
  /*!
   * ֤֡ڤؤޤ
   * @param f 
   */
  void select(bool f) {
    sel = f;
  }

  //! ֤μ
  /*!
   * ߤ֤֡ޤ
   * @retval true 
   * @retval false 
   */
  bool isSelected() const {
    return sel;
  }

};


//! 򥹥ȥ
/*!
 * ΰб륹ȥǤ
 */
class SelectionStroke : public AbstractStroke {

  static int lwidth; //!< 
  static LATTR lattr; //!< °
  static PAT pat_line; //!< Ѥѥ  
  static PAT pat_fill; //!< ΰɤĤ֤Ѥѥ
  static DCM dcm_line; //!< ⡼
  static DCM dcm_fill; //!< ⡼

  //! ϰϤѤߤ?
  mutable bool sel_finished;

 public:

  //! 󥹥ȥ饯
  SelectionStroke() : AbstractStroke(), sel_finished(false) {}

  //! ΰνλ
  /*!
   * ΰλޤ
   */
  void finishSelection() const {
    sel_finished = true;
  }

  //! ΰνλå
  /*!
   * ΰ򤬽äƤ뤫ɤĴ٤ޤ
   * @retval true λѤ
   * @retval false ޤ
   */
  bool isSelectionFinished() const {
    return sel_finished;
  }

  //! 
  /*!
   * ĶԤޤ
   * @param gid Ķ(GID)
   * @param lb Yɸβ
   * @param ub Yɸξ
   * @return 顼(0ʤｪλ)
   */
  W draw(W gid, int lb, int ub) const;

  //! Ǹ
  /*!
   * Ǹ줿ʬԤޤ
   * @param gid Ķ(GID)
   * @return 顼(0ʤｪλ)
   */
  W drawLatest(W gid) const;

  virtual void clear();

  //! Ƚ
  /*!
   * Ϳ줿ɸޤޤƤ뤫򸡺ޤ
   * @param p ɸ
   * @retval true ޤޤƤ
   * @retval false ޤޤƤʤ
   */
  bool contain(const PNT& p) const;

  //! 襹ȥȽ
  /*!
   * Ϳ줿ȥޤޤƤ뤫򸡺ޤ(̩ǤϤʤ)
   * @param stroke 襹ȥ
   * @retval true ޤޤƤ
   * @retval false ޤޤƤʤ
   */
  bool contain(DrawingStroke& stroke) const;

};

#endif // STROKE_H
