/*!
 * @file main.cc
 * @brief MAINؿ(C++ؤΥ)
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2005-01-26, 
 *
 * Copyright (C) 2005, Yashiro Takeshi
 */

#include <basic.h>
#include <bstdio.h>
#include <bassert.h>
#include <btron/libapp.h>
#include <btron/vobj.h>
#include "tcsliteral.h"
#include "databox.h"
#include "MainWindow.h"
#include "Exception.h"

//! 󥯤μ
/*!
 * MESSAGE¤Τ顢ԽоݤȤʤեΥ󥯤ޤ
 * @param msg MESSAGE¤
 * @return msgLINK¤ΤؤΥݥ
 */
static LINK* getTargetLink(MESSAGE* msg)
{
  switch (msg->msg_type){
  case EXECREQ:
    if ((((M_EXECREQ*)msg)->mode & 0x0002) != 0) {
      // ʪưΤǧᡢȵưϰ۾ｪλ
      oend_prc(((M_EXECREQ*)msg)->vid, NULL, 0);
      return 0;
    }
    return &(((M_EXECREQ*)msg)->lnk);
  case FUSENREQ: // 䵤Υץư
    oend_prc(((M_FUSENREQ*)msg)->vid, NULL, 0);
    return 0;
  case DISPREQ: // Ȥɽư
    oend_req(((M_DISPREQ*)msg)->vid, 1);
    return 0;
  case PASTEREQ: // ǡŽߵư
    oend_req(((M_PASTEREQ*)msg)->vid, 1);
    return 0;
  case TADREQ: // ȤTADǡư
    oend_req(((M_TADREQ*)msg)->vid, 1);
    return 0;
  default:
    return 0;
  }
  return 0;
}

//! ᥤؿ
/*!
 * ᥤؿǤ
 * @param msg ưå
 * @retval 0 ｪλ
 * @retval ¾ 顼λ
 */
extern "C" W MAIN(MESSAGE* msg)
{
  W retval = 0;
  
  LINK *link = getTargetLink(msg);
  if (link == 0){
    errpanel(EPNL_FNSPEC, 0);
    return -1;
  }
  
  LINK self;
  prc_inf(0, PI_LINK, &self, sizeof(LINK));
  opendbox(&self, USER_DATA, 0x2000);
  getscreen();
  initstdpnl();
  
  // ư¹
  try {
    MainWindow window;
    window.display(true);
    window.openDocument(link);
    osta_prc(((M_EXECREQ*)msg)->vid, window.getWindowID());
    window.run();
  }
  catch (FailureException& e){
    e.errorPanel();
    retval = -1;
  }
  catch (FileOpenException &e){
    errpanel(EPNL_OPEN, 0);
    retval = -1;
  }
  catch (FileWriteException& e){
    errpanel(EPNL_WRITE, 0);
    retval = -1;
  }
  catch (FileReadException& e){
    errpanel(EPNL_READ, 0);
    retval = -1;
  }
  catch (std::bad_alloc e){
    errpanel(EPNL_MEM, 0);
    retval = -1;
  }
  catch (...){
    errpanel(EPNL_UNDEF, 0);
    retval = -2;
  }
  oend_prc(((M_EXECREQ*)msg)->vid, NULL, 0);
  closedbox();
  
  // return retval; ȤɤCPU㳰ˤʤäƤޤ
  ext_prc(retval);
}

